blob: 3fe638b77d59b15f1ac6a8a0c4c1a8b09e8f43f6 [file] [log] [blame]
Chris Masone2aa55332011-12-30 14:41:07 -08001#!/bin/bash
2#
3# Copyright (c) 2012 The Chromium OS Authors. All rights reserved.
4# Use of this source code is governed by a BSD-style license that can be
5# found in the LICENSE file.
6
7USAGE="Usage: setup_dev_autotest.sh [-p <password>] [-a </path/to/autotest>]"
8HELP="${USAGE}\n\n\
9Install and configure software needed to run autotest locally.\n\
10If you're just working on tests, you do not need to run this.\n\n\
11Options:\n\
12 -p Desired Autotest DB password\n\
13 -a Absolute path to autotest source tree.\n"
14
15AUTOTEST_DIR=
16PASSWD=
17while getopts ":p:a:h" opt; do
18 case $opt in
19 a)
20 AUTOTEST_DIR=$OPTARG
21 ;;
22 p)
23 PASSWD=$OPTARG
24 ;;
25 h)
26 echo -e "${HELP}" >&2
27 exit 0
28 ;;
29 \?)
30 echo "Invalid option: -$OPTARG" >&2
31 echo "${USAGE}" >&2
32 exit 1
33 ;;
34 :)
35 echo "Option -$OPTARG requires an argument." >&2
36 echo "${USAGE}" >&2
37 exit 1
38 ;;
39 esac
40done
41
42if [ -z ${PASSWD} ]; then
43 read -s -p "Autotest DB password: " PASSWD
44 echo
45 if [ -z ${PASSWD} ]; then
46 echo "Empty passwords not allowed." >&2
47 exit 1
48 fi
49 read -s -p "Re-enter password: " PASSWD2
50 echo
51 if [ ${PASSWD} != ${PASSWD2} ]; then
52 echo "Passwords don't match." >&2
53 exit 1
54 fi
55fi
56
57if [ -z "${AUTOTEST_DIR}" ]; then
58 CANDIDATE=$(dirname "$(readlink -f "$0")" | egrep -o '(/[^/]+)*/files')
59 read -p "Enter autotest dir [${CANDIDATE}]: " AUTOTEST_DIR
60 if [ -z "${AUTOTEST_DIR}" ]; then
61 AUTOTEST_DIR="${CANDIDATE}"
62 fi
63fi
64
65SHADOW_CONFIG_PATH="${AUTOTEST_DIR}/shadow_config.ini"
66echo "Autotest supports local overrides of global configuration through a "
67echo "'shadow' configuration file. Setting one up for you now."
68if [ -f ${SHADOW_CONFIG_PATH} ]; then
69 clobber=
70 while read -n 1 -p "Clobber existing shadow config? [Y/n]: " clobber; do
71 echo
72 if [[ -z ${clobber} || $(echo ${clobber} | egrep -qi 'y|n') -eq 0 ]]; then
73 break
74 fi
75 echo "Please enter y or n."
76 done
77 if [[ ${clobber} = 'n' || ${clobber} = 'N' ]]; then
78 echo "Refusing to clobber existing shadow_config.ini."
79 exit 0
80 fi
81 echo "Clobbering existing shadow_config.ini."
82fi
83
84cat > "${SHADOW_CONFIG_PATH}" <<EOF
85[AUTOTEST_WEB]
86host: localhost
87password: ${PASSWD}
88
89[SERVER]
90hostname: localhost
91EOF
92echo -e "Done!\n"
93
94echo "Installing needed Ubuntu packages..."
95PKG_LIST="mysql-server mysql-common libapache2-mod-python python-mysqldb \
96gnuplot apache2-mpm-prefork unzip python-imaging libpng12-dev libfreetype6-dev \
97sqlite3 python-pysqlite2 git-core pbzip2 openjdk-6-jre openjdk-6-jdk \
98python-crypto python-dev subversion build-essential python-setuptools"
99
100if ! sudo apt-get install -y ${PKG_LIST}; then
101 echo "Could not install packages: $?"
102 exit 1
103fi
104echo -e "Done!\n"
105
106echo -n "Setting up Database: chromeos_autotest_db in MySQL..."
107SQL_COMMAND="create database chromeos_autotest_db; \
108grant all privileges on chromeos_autotest_db.* TO \
109'chromeosqa-admin'@'localhost' identified by '${PASSWD}'; \
110FLUSH PRIVILEGES;"
111
112if mysql -u root -e ';' 2> /dev/null ; then
113 PASSWD_STRING=
114elif mysql -u root -p"${PASSWD}" -e ';' 2> /dev/null ; then
115 PASSWD_STRING="-p${PASSWD}"
116else
117 PASSWD_STRING="-p"
118fi
119
120set -e
121
122mysql -u root "${PASSWD_STRING}" -e "${SQL_COMMAND}"
123echo -e "Done!\n"
124
125AT_DIR=/usr/local/autotest
126echo -n "Bind-mounting your autotest dir at ${AT_DIR}..."
127sudo mkdir -p "${AT_DIR}"
128sudo mount --bind "${AUTOTEST_DIR}" "${AT_DIR}"
129echo -e "Done!\n"
130
131EXISTING_MOUNT=$(egrep "/.+[[:space:]]${AT_DIR}" /etc/fstab || /bin/true)
132if [ -n "${EXISTING_MOUNT}" ]; then
133 echo "${EXISTING_MOUNT}" | awk '{print $1 " already automounting at " $2}'
134 echo "We won't update /etc/fstab, but you should have a line line this:"
135 echo -e "${AUTOTEST_DIR}\t${AT_DIR}\tbind defaults,bind\t0\t0"
136else
137 echo -n "Adding aforementioned bind-mount to /etc/fstab..."
138 # Is there a better way to elevate privs and do a redirect?
139 sudo su -c \
140 "echo -e '${AUTOTEST_DIR}\t${AT_DIR}\tbind defaults,bind\t0\t0' \
141 >> /etc/fstab"
142 echo -e "Done!\n"
143fi
144
145echo -n "Reticulating splines..."
146"${AT_DIR}"/utils/build_externals.py &> /dev/null
147"${AT_DIR}"/utils/compile_gwt_clients.py -a &> /dev/null
148echo -e "Done!\n"
149
150echo "Populating autotest mysql DB..."
151"${AT_DIR}"/database/migrate.py sync
152"${AT_DIR}"/frontend/manage.py syncdb
153# You may have to run this twice.
154"${AT_DIR}"/frontend/manage.py syncdb
155"${AT_DIR}"/utils/test_importer.py
156echo -e "Done!\n"
157
158echo "Configuring apache to run the autotest web interface..."
159sudo ln -sf "${AT_DIR}"/apache/apache-conf \
160 /etc/apache2/sites-available/autotest-server
161# disable currently active default
162sudo a2dissite default
163# enable autotest server
164sudo a2ensite autotest-server
165# Enable rewrite module
166sudo a2enmod rewrite
167# Setup permissions so that Apache web user can read the proper files.
168chmod -R o+r "${AT_DIR}"
169find "${AT_DIR}"/ -type d | xargs chmod o+x
170chmod o+x "${AT_DIR}"/tko/*.cgi
171# restart server
172sudo /etc/init.d/apache2 restart
173
174echo "Browse to http://localhost to see if Autotest is working."
175echo "For further necessary set up steps, see https://sites.google.com/a/chromium.org/dev/chromium-os/testing/autotest-developer-faq/setup-autotest-server?pli=1"